function [A] = CircleArea(x1, y1, r1, x2, y2, r2)

% x1, y1 = position of center of circle 1
% r1 = radius of circle 1
% x2, y2 = position of center of circle 2
% r2 = radius of circle 2
% If circles do no intersect, output will be 0
% If one circle is entirely within the other circle, the area of the
% smaller circle will be output

d = sqrt((x1-x2)^2+(y1-y2)^2); 

if d>r1+r2 % circles do not intersect
    A = 0;
elseif d+r1<r2 % c1 is inside c2
A = 2*pi*r1^2;
elseif d+r2<r1 % c2 is inside c1
A = 2*pi*r2^2;
else
t = sqrt((d+r1+r2)*(d+r1-r2)*(d-r1+r2)*(-d+r1+r2));
   A = r1^2*atan2(t,d^2+r1^2-r2^2)+r2^2*atan2(t,d^2-r1^2+r2^2)-t/2;
end